/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     INT_CONSTANT = 259,
     DOUBLE_CONSTANT = 260,
     LONG_CONSTANT = 261,
     FLOAT_CONSTANT = 262,
     UNSIGNED_INT_CONSTANT = 263,
     UNSIGNED_LONG_CONSTANT = 264,
     LONG_DOUBLE_CONSTANT = 265,
     STRING_LITERAL = 266,
     SIZEOF = 267,
     PTR_OP = 268,
     INC_OP = 269,
     DEC_OP = 270,
     LEFT_OP = 271,
     RIGHT_OP = 272,
     LE_OP = 273,
     GE_OP = 274,
     EQ_OP = 275,
     NE_OP = 276,
     AND_OP = 277,
     OR_OP = 278,
     MUL_ASSIGN = 279,
     DIV_ASSIGN = 280,
     MOD_ASSIGN = 281,
     ADD_ASSIGN = 282,
     SUB_ASSIGN = 283,
     LEFT_ASSIGN = 284,
     RIGHT_ASSIGN = 285,
     AND_ASSIGN = 286,
     XOR_ASSIGN = 287,
     OR_ASSIGN = 288,
     TYPE_NAME = 289,
     TYPEDEF = 290,
     EXTERN = 291,
     STATIC = 292,
     AUTO = 293,
     REGISTER = 294,
     CHAR = 295,
     SHORT = 296,
     INT = 297,
     LONG = 298,
     SIGNED = 299,
     UNSIGNED = 300,
     FLOAT = 301,
     DOUBLE = 302,
     CONST = 303,
     VOLATILE = 304,
     VOID = 305,
     STRUCT = 306,
     UNION = 307,
     ENUM = 308,
     ELIPSIS = 309,
     CASE = 310,
     DEFAULT = 311,
     IF = 312,
     ELSE = 313,
     SWITCH = 314,
     WHILE = 315,
     DO = 316,
     FOR = 317,
     GOTO = 318,
     CONTINUE = 319,
     BREAK = 320,
     RETURN = 321,
     BAD = 322
   };
#endif
#define IDENTIFIER 258
#define INT_CONSTANT 259
#define DOUBLE_CONSTANT 260
#define LONG_CONSTANT 261
#define FLOAT_CONSTANT 262
#define UNSIGNED_INT_CONSTANT 263
#define UNSIGNED_LONG_CONSTANT 264
#define LONG_DOUBLE_CONSTANT 265
#define STRING_LITERAL 266
#define SIZEOF 267
#define PTR_OP 268
#define INC_OP 269
#define DEC_OP 270
#define LEFT_OP 271
#define RIGHT_OP 272
#define LE_OP 273
#define GE_OP 274
#define EQ_OP 275
#define NE_OP 276
#define AND_OP 277
#define OR_OP 278
#define MUL_ASSIGN 279
#define DIV_ASSIGN 280
#define MOD_ASSIGN 281
#define ADD_ASSIGN 282
#define SUB_ASSIGN 283
#define LEFT_ASSIGN 284
#define RIGHT_ASSIGN 285
#define AND_ASSIGN 286
#define XOR_ASSIGN 287
#define OR_ASSIGN 288
#define TYPE_NAME 289
#define TYPEDEF 290
#define EXTERN 291
#define STATIC 292
#define AUTO 293
#define REGISTER 294
#define CHAR 295
#define SHORT 296
#define INT 297
#define LONG 298
#define SIGNED 299
#define UNSIGNED 300
#define FLOAT 301
#define DOUBLE 302
#define CONST 303
#define VOLATILE 304
#define VOID 305
#define STRUCT 306
#define UNION 307
#define ENUM 308
#define ELIPSIS 309
#define CASE 310
#define DEFAULT 311
#define IF 312
#define ELSE 313
#define SWITCH 314
#define WHILE 315
#define DO 316
#define FOR 317
#define GOTO 318
#define CONTINUE 319
#define BREAK 320
#define RETURN 321
#define BAD 322




/* Copy the first part of user declarations.  */
#line 7 "parse.y"


#if 0
#define ST_DUMP
#endif
#if 0
#define PRINTTREE
#endif

#include <string.h>
#include <stdlib.h>

#include "defs.h"
#include "decl.h"
#include "types.h"
#include "bucket.h"
#include "symtab.h"
#include "message.h"
#include "tree.h"
#include "analyze.h"
#include "globals.h"
#include "decl2.h"
#include "constExpr.h"
#include "encode.h"

void yyerror(char *s);
int yylex(void);

extern GP_SWITCH g_id_lookup;   /*  lsr,  05/08/01 */

/* used to concatenate string literals */
static char* concat(char* first, char* second);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 41 "parse.y"
typedef union YYSTYPE {
  int             y_int;
  long            y_long;
  unsigned int    y_uint;
  unsigned long   y_ulong;
  double          y_double;
  float           y_float;
  long double     y_ldouble;
  char *          y_string;
  ST_ID           y_id;
  BUCKET_PTR      y_bucket_ptr; 
  Type            y_type; 
  MemberList      y_member_list;
  ParamList       y_param_list;
  PARAM_TYPE_LIST y_param_type_list;
  TYPE_SPECIFIER  y_type_specifier;
  MY_SPECIFIER    y_my_specifier;
  TypeQualifier   y_type_qualifier;
  StorageClass    y_storage_class;
  ST_DR           y_st_dr;
  DECLARATOR_LIST y_declarator_list; 
  DECL_TREE       y_decl_tree;
  Tree            y_tree;
  ExpTree         y_exptree;
  TreeOp          y_treeop;
  } YYSTYPE;
/* Line 191 of yacc.c.  */
#line 270 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 282 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  73
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1675

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  92
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  77
/* YYNRULES -- Number of rules. */
#define YYNRULES  242
/* YYNRULES -- Number of states. */
#define YYNSTATES  403

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   322

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,     2,     2,     2,    81,    74,     2,
      68,    69,    75,    76,    73,    77,    72,    80,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    87,    89,
      82,    88,    83,    86,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    70,     2,    71,    84,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    90,    85,    91,    78,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    25,    27,    32,    36,    41,    45,    49,    52,
      55,    57,    61,    63,    66,    69,    72,    75,    80,    82,
      84,    86,    88,    90,    92,    94,    99,   101,   105,   109,
     113,   115,   119,   123,   125,   129,   133,   135,   139,   143,
     147,   151,   153,   157,   161,   163,   167,   169,   173,   175,
     179,   181,   185,   187,   191,   193,   199,   201,   205,   207,
     209,   211,   213,   215,   217,   219,   221,   223,   225,   227,
     229,   233,   235,   238,   242,   244,   247,   249,   252,   254,
     257,   259,   263,   265,   266,   271,   273,   275,   277,   279,
     281,   283,   285,   287,   289,   291,   293,   295,   297,   299,
     301,   303,   305,   306,   312,   313,   314,   322,   325,   327,
     329,   331,   334,   338,   341,   343,   346,   348,   351,   353,
     357,   359,   362,   366,   371,   377,   380,   382,   384,   388,
     390,   394,   396,   398,   400,   403,   405,   408,   410,   414,
     418,   423,   427,   430,   434,   435,   439,   441,   444,   447,
     451,   453,   457,   459,   463,   466,   468,   471,   473,   477,
     479,   482,   484,   486,   489,   493,   496,   500,   504,   509,
     512,   516,   520,   525,   527,   531,   536,   538,   542,   544,
     546,   548,   550,   552,   554,   557,   561,   566,   570,   571,
     575,   577,   580,   583,   587,   589,   592,   594,   597,   599,
     602,   608,   616,   622,   628,   636,   643,   651,   659,   668,
     676,   685,   694,   704,   708,   711,   714,   717,   721,   723,
     726,   728,   730,   733,   736,   737,   742,   747,   748,   754,
     760,   762,   764
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
     162,     0,    -1,   167,    -1,     4,    -1,     5,    -1,   168,
      -1,     6,    -1,     7,    -1,     8,    -1,     9,    -1,    10,
      -1,    68,   112,    69,    -1,    93,    -1,    94,    70,   112,
      71,    -1,    94,    68,    69,    -1,    94,    68,    95,    69,
      -1,    94,    72,   167,    -1,    94,    13,   167,    -1,    94,
      14,    -1,    94,    15,    -1,   110,    -1,   110,    73,    95,
      -1,    94,    -1,    14,    96,    -1,    15,    96,    -1,    97,
      98,    -1,    12,    96,    -1,    12,    68,   146,    69,    -1,
      74,    -1,    75,    -1,    76,    -1,    77,    -1,    78,    -1,
      79,    -1,    96,    -1,    68,   146,    69,    98,    -1,    98,
      -1,    99,    75,    98,    -1,    99,    80,    98,    -1,    99,
      81,    98,    -1,    99,    -1,   100,    76,    99,    -1,   100,
      77,    99,    -1,   100,    -1,   101,    16,   100,    -1,   101,
      17,   100,    -1,   101,    -1,   102,    82,   101,    -1,   102,
      83,   101,    -1,   102,    18,   101,    -1,   102,    19,   101,
      -1,   102,    -1,   103,    20,   102,    -1,   103,    21,   102,
      -1,   103,    -1,   104,    74,   103,    -1,   104,    -1,   105,
      84,   104,    -1,   105,    -1,   106,    85,   105,    -1,   106,
      -1,   107,    22,   106,    -1,   107,    -1,   108,    23,   107,
      -1,   108,    -1,   108,    86,   112,    87,   109,    -1,   109,
      -1,    96,   111,   110,    -1,    88,    -1,    24,    -1,    25,
      -1,    26,    -1,    27,    -1,    28,    -1,    29,    -1,    30,
      -1,    31,    -1,    32,    -1,    33,    -1,   110,    -1,   112,
      73,   110,    -1,   109,    -1,   115,    89,    -1,   115,   116,
      89,    -1,   119,    -1,   119,   115,    -1,   120,    -1,   120,
     115,    -1,   135,    -1,   135,   115,    -1,   117,    -1,   116,
      73,   117,    -1,   137,    -1,    -1,   137,    88,   118,   149,
      -1,    35,    -1,    36,    -1,    37,    -1,    38,    -1,    39,
      -1,    50,    -1,    40,    -1,    41,    -1,    42,    -1,    43,
      -1,    46,    -1,    47,    -1,    44,    -1,    45,    -1,   121,
      -1,   131,    -1,    34,    -1,    -1,   125,    90,   122,   126,
      91,    -1,    -1,    -1,   125,   167,   123,    90,   124,   126,
      91,    -1,   125,   167,    -1,    51,    -1,    52,    -1,   127,
      -1,   126,   127,    -1,   128,   129,    89,    -1,     1,    89,
      -1,   120,    -1,   120,   128,    -1,   135,    -1,   135,   128,
      -1,   130,    -1,   129,    73,   130,    -1,   137,    -1,    87,
     113,    -1,   137,    87,   113,    -1,   132,    90,   133,    91,
      -1,   132,   167,    90,   133,    91,    -1,   132,   167,    -1,
      53,    -1,   134,    -1,   133,    73,   134,    -1,   167,    -1,
     167,    88,   113,    -1,    48,    -1,    49,    -1,   135,    -1,
     136,   135,    -1,   138,    -1,   141,   138,    -1,   167,    -1,
      68,   137,    69,    -1,   138,    70,    71,    -1,   138,    70,
     113,    71,    -1,   139,   142,    69,    -1,   139,    69,    -1,
     139,   145,    69,    -1,    -1,   138,   140,    68,    -1,    75,
      -1,    75,   136,    -1,    75,   141,    -1,    75,   136,   141,
      -1,   143,    -1,   143,    73,    54,    -1,   144,    -1,   143,
      73,   144,    -1,   115,   137,    -1,   115,    -1,   115,   147,
      -1,   167,    -1,   145,    73,   167,    -1,   128,    -1,   128,
     147,    -1,   141,    -1,   148,    -1,   141,   148,    -1,    68,
     147,    69,    -1,    70,    71,    -1,    70,   113,    71,    -1,
     148,    70,    71,    -1,   148,    70,   113,    71,    -1,    68,
      69,    -1,    68,   142,    69,    -1,   148,    68,    69,    -1,
     148,    68,   142,    69,    -1,   110,    -1,    90,   150,    91,
      -1,    90,   150,    73,    91,    -1,   149,    -1,   150,    73,
     149,    -1,   152,    -1,   153,    -1,   158,    -1,   159,    -1,
     160,    -1,   161,    -1,     1,    89,    -1,   167,    87,   151,
      -1,    55,   113,    87,   151,    -1,    56,    87,   151,    -1,
      -1,    90,   154,   155,    -1,    91,    -1,   157,    91,    -1,
     156,    91,    -1,   156,   157,    91,    -1,   114,    -1,   156,
     114,    -1,   151,    -1,   151,   157,    -1,    89,    -1,   112,
      89,    -1,    57,    68,   112,    69,   151,    -1,    57,    68,
     112,    69,   151,    58,   151,    -1,    59,    68,   112,    69,
     151,    -1,    60,    68,   112,    69,   151,    -1,    61,   151,
      60,    68,   112,    69,    89,    -1,    62,    68,    89,    89,
      69,   151,    -1,    62,    68,    89,    89,   112,    69,   151,
      -1,    62,    68,    89,   112,    89,    69,   151,    -1,    62,
      68,    89,   112,    89,   112,    69,   151,    -1,    62,    68,
     112,    89,    89,    69,   151,    -1,    62,    68,   112,    89,
      89,   112,    69,   151,    -1,    62,    68,   112,    89,   112,
      89,    69,   151,    -1,    62,    68,   112,    89,   112,    89,
     112,    69,   151,    -1,    63,   167,    89,    -1,    64,    89,
      -1,    65,    89,    -1,    66,    89,    -1,    66,   112,    89,
      -1,   163,    -1,   162,   163,    -1,   164,    -1,   114,    -1,
       1,    89,    -1,     1,    91,    -1,    -1,   137,    90,   165,
     155,    -1,   137,   156,    90,   155,    -1,    -1,   115,   137,
      90,   166,   155,    -1,   115,   137,   156,    90,   155,    -1,
       3,    -1,    11,    -1,   168,    11,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   139,   139,   143,   147,   151,   156,   160,   164,   168,
     172,   176,   183,   187,   191,   195,   199,   203,   207,   211,
     218,   222,   229,   233,   237,   241,   245,   249,   256,   260,
     264,   268,   272,   276,   283,   287,   294,   298,   302,   306,
     313,   317,   321,   328,   332,   336,   343,   347,   351,   355,
     359,   366,   370,   374,   381,   385,   392,   396,   403,   407,
     414,   418,   425,   429,   436,   440,   447,   451,   458,   462,
     466,   470,   474,   478,   482,   486,   490,   494,   498,   505,
     509,   516,   527,   538,   557,   561,   565,   570,   575,   579,
     586,   590,   599,   604,   603,   615,   616,   617,   618,   619,
     623,   628,   633,   638,   643,   648,   653,   658,   663,   668,
     673,   679,   688,   687,   696,   701,   695,   714,   721,   726,
     734,   738,   745,   753,   761,   766,   771,   775,   782,   786,
     794,   795,   796,   800,   804,   808,   815,   822,   823,   827,
     831,   839,   840,   844,   848,   855,   859,   866,   870,   874,
     878,   889,   893,   897,   906,   905,   914,   918,   922,   926,
     933,   938,   946,   950,   957,   965,   973,   984,   985,   989,
     994,  1005,  1009,  1013,  1020,  1024,  1028,  1039,  1043,  1054,
    1058,  1062,  1066,  1073,  1074,  1075,  1079,  1080,  1084,  1088,
    1092,  1096,  1100,  1104,  1108,  1115,  1119,  1123,  1131,  1130,
    1145,  1149,  1153,  1157,  1164,  1165,  1169,  1173,  1179,  1183,
    1190,  1194,  1198,  1205,  1209,  1213,  1217,  1221,  1225,  1229,
    1233,  1237,  1241,  1248,  1252,  1256,  1260,  1264,  1271,  1272,
    1276,  1277,  1278,  1282,  1290,  1289,  1324,  1329,  1328,  1362,
    1370,  1377,  1381
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "INT_CONSTANT", 
  "DOUBLE_CONSTANT", "LONG_CONSTANT", "FLOAT_CONSTANT", 
  "UNSIGNED_INT_CONSTANT", "UNSIGNED_LONG_CONSTANT", 
  "LONG_DOUBLE_CONSTANT", "STRING_LITERAL", "SIZEOF", "PTR_OP", "INC_OP", 
  "DEC_OP", "LEFT_OP", "RIGHT_OP", "LE_OP", "GE_OP", "EQ_OP", "NE_OP", 
  "AND_OP", "OR_OP", "MUL_ASSIGN", "DIV_ASSIGN", "MOD_ASSIGN", 
  "ADD_ASSIGN", "SUB_ASSIGN", "LEFT_ASSIGN", "RIGHT_ASSIGN", "AND_ASSIGN", 
  "XOR_ASSIGN", "OR_ASSIGN", "TYPE_NAME", "TYPEDEF", "EXTERN", "STATIC", 
  "AUTO", "REGISTER", "CHAR", "SHORT", "INT", "LONG", "SIGNED", 
  "UNSIGNED", "FLOAT", "DOUBLE", "CONST", "VOLATILE", "VOID", "STRUCT", 
  "UNION", "ENUM", "ELIPSIS", "CASE", "DEFAULT", "IF", "ELSE", "SWITCH", 
  "WHILE", "DO", "FOR", "GOTO", "CONTINUE", "BREAK", "RETURN", "BAD", 
  "'('", "')'", "'['", "']'", "'.'", "','", "'&'", "'*'", "'+'", "'-'", 
  "'~'", "'!'", "'/'", "'%'", "'<'", "'>'", "'^'", "'|'", "'?'", "':'", 
  "'='", "';'", "'{'", "'}'", "$accept", "primary_expr", "postfix_expr", 
  "argument_expr_list", "unary_expr", "unary_operator", "cast_expr", 
  "multiplicative_expr", "additive_expr", "shift_expr", "relational_expr", 
  "equality_expr", "and_expr", "exclusive_or_expr", "inclusive_or_expr", 
  "logical_and_expr", "logical_or_expr", "conditional_expr", 
  "assignment_expr", "assignment_operator", "expr", "constant_expr", 
  "declaration", "declaration_specifiers", "init_declarator_list", 
  "init_declarator", "@1", "storage_class_specifier", "type_specifier", 
  "struct_or_union_specifier", "@2", "@3", "@4", "struct_or_union", 
  "struct_declaration_list", "struct_declaration", 
  "specifier_qualifier_list", "struct_declarator_list", 
  "struct_declarator", "enum_specifier", "enum_keyword", 
  "enumerator_list", "enumerator", "type_qualifier", 
  "type_qualifier_list", "declarator", "direct_declarator", 
  "direct_declarator_func_start", "@5", "pointer", "parameter_type_list", 
  "parameter_list", "parameter_declaration", "identifier_list", 
  "type_name", "abstract_declarator", "direct_abstract_declarator", 
  "initializer", "initializer_list", "statement", "labeled_statement", 
  "compound_statement", "@6", "compound_statement_tail", 
  "declaration_list", "statement_list", "expression_statement", 
  "selection_statement", "iteration_statement", "jump_statement", 
  "translation_unit", "external_declaration", "function_definition", "@7", 
  "@8", "identifier", "string_literal", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,    40,    41,
      91,    93,    46,    44,    38,    42,    43,    45,   126,    33,
      47,    37,    60,    62,    94,   124,    63,    58,    61,    59,
     123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    92,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    94,    94,    94,    94,    94,    94,    94,    94,
      95,    95,    96,    96,    96,    96,    96,    96,    97,    97,
      97,    97,    97,    97,    98,    98,    99,    99,    99,    99,
     100,   100,   100,   101,   101,   101,   102,   102,   102,   102,
     102,   103,   103,   103,   104,   104,   105,   105,   106,   106,
     107,   107,   108,   108,   109,   109,   110,   110,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   112,
     112,   113,   114,   114,   115,   115,   115,   115,   115,   115,
     116,   116,   117,   118,   117,   119,   119,   119,   119,   119,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   122,   121,   123,   124,   121,   121,   125,   125,
     126,   126,   127,   127,   128,   128,   128,   128,   129,   129,
     130,   130,   130,   131,   131,   131,   132,   133,   133,   134,
     134,   135,   135,   136,   136,   137,   137,   138,   138,   138,
     138,   138,   138,   138,   140,   139,   141,   141,   141,   141,
     142,   142,   143,   143,   144,   144,   144,   145,   145,   146,
     146,   147,   147,   147,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   149,   149,   149,   150,   150,   151,   151,
     151,   151,   151,   151,   151,   152,   152,   152,   154,   153,
     155,   155,   155,   155,   156,   156,   157,   157,   158,   158,
     159,   159,   159,   160,   160,   160,   160,   160,   160,   160,
     160,   160,   160,   161,   161,   161,   161,   161,   162,   162,
     163,   163,   163,   163,   165,   164,   164,   166,   164,   164,
     167,   168,   168
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     4,     3,     4,     3,     3,     2,     2,
       1,     3,     1,     2,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     3,     3,     3,
       1,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     1,     3,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     5,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     3,     1,     2,     1,     2,     1,     2,
       1,     3,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     0,     0,     7,     2,     1,     1,
       1,     2,     3,     2,     1,     2,     1,     2,     1,     3,
       1,     2,     3,     4,     5,     2,     1,     1,     3,     1,
       3,     1,     1,     1,     2,     1,     2,     1,     3,     3,
       4,     3,     2,     3,     0,     3,     1,     2,     2,     3,
       1,     3,     1,     3,     2,     1,     2,     1,     3,     1,
       2,     1,     1,     2,     3,     2,     3,     3,     4,     2,
       3,     3,     4,     1,     3,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     2,     3,     4,     3,     0,     3,
       1,     2,     2,     3,     1,     2,     1,     2,     1,     2,
       5,     7,     5,     5,     7,     6,     7,     7,     8,     7,
       8,     8,     9,     3,     2,     2,     2,     3,     1,     2,
       1,     1,     2,     2,     0,     4,     4,     0,     5,     5,
       1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,   240,   111,    95,    96,    97,    98,    99,   101,
     102,   103,   104,   107,   108,   105,   106,   141,   142,   100,
     118,   119,   136,     0,   156,   231,     0,    84,    86,   109,
       0,   110,     0,    88,     0,   145,     0,     0,     0,   228,
     230,   147,   232,   233,     0,   143,   157,   158,    82,     0,
      90,    92,    85,    87,   112,   117,     0,   135,    89,   234,
     204,     0,     0,     0,     0,   152,   165,     0,   160,   162,
       0,   167,   146,     1,   229,   148,   144,   159,     0,    83,
      93,   237,     0,     0,     0,     0,   137,   139,     0,     0,
      92,     0,   205,     3,     4,     6,     7,     8,     9,    10,
     241,     0,     0,     0,     0,   149,    28,    29,    30,    31,
      32,    33,    12,    22,    34,     0,    36,    40,    43,    46,
      51,    54,    56,    58,    60,    62,    64,    81,     0,     2,
       5,   155,     0,     0,   164,   171,   166,   172,   151,     0,
     153,     0,    91,     0,     0,     0,     0,   124,     0,   120,
       0,   126,   115,     0,   133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     198,   200,    34,    66,    79,     0,     0,   188,   189,   235,
       0,     0,   190,   191,   192,   193,     2,   236,     0,    26,
       0,    23,    24,     0,   169,     0,     0,    18,    19,     0,
       0,     0,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,   242,   179,     0,     0,   175,     0,   173,
       0,     0,   161,   163,   168,     0,   183,    94,   238,   239,
     123,   125,   113,   121,     0,     0,   128,   130,   127,     0,
     138,   140,   134,   194,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,     0,     0,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    68,     0,     0,
     209,   207,   202,     0,   201,     0,     0,    11,     0,   171,
     170,     0,    17,    14,     0,    20,     0,    16,    37,    38,
      39,    41,    42,    44,    45,    49,    50,    47,    48,    52,
      53,    55,    57,    59,    61,    63,     0,   180,   174,   176,
     181,     0,   177,     0,   186,     0,   131,     0,   122,     0,
       0,     0,   197,     0,     0,     0,     0,     0,     0,   223,
     227,   199,    67,    80,   203,   195,    27,    35,    15,     0,
      13,     0,   182,   178,     0,   184,   129,   132,   116,   196,
       0,     0,     0,     0,     0,     0,     0,    21,    65,   185,
     187,   210,   212,   213,     0,     0,     0,     0,     0,     0,
       0,     0,   215,     0,     0,     0,     0,     0,     0,   211,
     214,   216,   217,     0,   219,     0,     0,     0,   218,   220,
     221,     0,   222
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,   112,   113,   294,   172,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   173,   174,   278,
     175,   128,    60,    61,    49,    50,   143,    27,    28,    29,
      83,    84,   249,    30,   148,   149,   150,   245,   246,    31,
      32,    85,    86,    33,    46,    34,    35,    36,    64,    37,
     225,    68,    69,    70,   195,   226,   137,   237,   325,   176,
     177,   178,   266,   179,   180,   181,   182,   183,   184,   185,
      38,    39,    40,    89,   144,   129,   130
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -226
static const short yypact[] =
{
     298,   -26,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,    26,    -8,  -226,    72,  1622,  1622,  -226,
       9,  -226,    10,  1622,  1423,    81,  1387,    24,  1285,  -226,
    -226,  -226,  -226,  -226,   -51,  -226,    -8,  -226,  -226,   -34,
    -226,   590,  -226,  -226,  -226,   -16,    25,    -6,  -226,  -226,
    -226,    72,  1443,   919,    29,  -226,   125,    45,    51,  -226,
     -49,  -226,    81,  -226,  -226,  -226,  -226,  -226,    26,  -226,
    -226,  -226,  1500,   866,     5,   -23,  -226,    66,    25,   426,
      69,   426,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  1192,  1205,  1205,   974,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,   530,  -226,  1231,  -226,   122,   115,   225,
     152,   252,   150,   143,   145,   217,    22,  -226,   193,  -226,
     239,  -226,  1336,  1025,  -226,    12,  -226,    96,  -226,  1601,
    -226,    25,  -226,   751,   426,   426,   170,  1474,   273,  -226,
      11,  1474,  -226,    25,  -226,  1231,   -22,   190,  1231,   197,
     209,   218,   220,   645,   232,    25,   213,   214,   768,  -226,
    -226,  -226,   509,  -226,  -226,    33,   608,  -226,  -226,  -226,
     517,   215,  -226,  -226,  -226,  -226,   223,  -226,   974,  -226,
    1231,  -226,  -226,   114,   168,   242,    25,  -226,  -226,  1051,
    1231,    25,  -226,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  -226,  -226,  -226,   259,   260,  -226,   284,    96,
    1565,  1064,  -226,  -226,  -226,   751,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  1231,    36,  -226,   269,  -226,   866,
    -226,  -226,  -226,  -226,   270,   645,  1231,  1231,  1231,   299,
     784,   274,  -226,  -226,  -226,    47,   426,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  1231,  1231,
    -226,  -226,  -226,   276,  -226,   645,   296,  -226,  1523,   195,
    -226,  1231,  -226,  -226,   300,   297,   205,  -226,  -226,  -226,
    -226,   122,   122,   115,   115,   225,   225,   225,   225,   152,
     152,   252,   150,   143,   145,   217,    85,  -226,  -226,  -226,
    -226,   302,  -226,   301,  -226,   -15,  -226,    11,  -226,  1231,
     405,   645,  -226,   156,   164,   171,   306,   871,    50,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  1231,
    -226,  1231,  -226,  -226,   733,  -226,  -226,  -226,  -226,  -226,
     645,   645,   645,  1231,  1077,    79,   887,  -226,  -226,  -226,
    -226,   318,  -226,  -226,   178,   645,   179,  1102,  1154,    89,
     645,   288,  -226,   645,   645,   180,   645,   187,  1179,  -226,
    -226,  -226,  -226,   645,  -226,   645,   645,   188,  -226,  -226,
    -226,   645,  -226
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -226,  -226,  -226,    30,     1,  -226,   -93,    84,    88,    58,
     139,   162,   165,   163,   166,   172,  -226,   -62,   -56,  -226,
     -83,   -98,     8,    16,  -226,   312,  -226,  -226,    38,  -226,
    -226,  -226,  -226,  -226,   142,  -146,   -70,  -226,    67,  -226,
    -226,   309,   245,   -21,  -226,   -19,   -20,  -226,  -226,   -13,
     -31,  -226,   261,  -226,   211,   -57,  -129,  -225,  -226,    27,
    -226,  -226,  -226,   -72,    -3,    82,  -226,  -226,  -226,  -226,
    -226,   365,  -226,  -226,  -226,     0,  -226
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -207
static const short yytable[] =
{
      41,   127,   243,    45,    44,    67,   229,    51,    25,   136,
     324,    47,     2,     2,     2,     2,    26,    72,    75,   187,
     140,   193,   202,    41,   141,    76,    41,     2,     2,     2,
      55,    62,    57,    77,   194,   228,    71,    41,    41,    78,
      17,    18,    90,    52,    53,   220,    25,   134,    82,    58,
     153,   153,    66,   135,    26,    79,    87,   251,   354,    90,
     254,    41,   151,    42,   114,    43,    41,    24,   154,   252,
      92,   127,   238,   239,  -114,     2,   355,   241,    41,    23,
     132,   248,   133,   151,    88,   265,    24,   236,    87,   186,
      92,   186,    23,   127,    23,   152,   127,   131,   244,    54,
      56,    24,   189,   191,   192,   193,   279,   193,   221,   327,
     298,   299,   300,    44,   138,    72,   114,   296,   194,   135,
     279,   147,   280,   279,   139,   328,   151,   151,     2,   370,
     151,   247,    41,   323,   114,    41,   340,   290,   316,   366,
      23,   234,   147,   295,   186,   186,   326,    24,    66,  -154,
      41,    63,   279,    87,   155,    66,   114,    80,   279,   114,
     229,    48,   279,   186,   230,   261,   231,   151,   377,   127,
     210,   211,   351,   333,   334,   335,   186,   338,   388,   236,
     186,   289,   127,   287,   243,   147,   147,   279,    92,   147,
     259,   206,   207,   132,   341,   133,   292,   203,   347,   321,
      24,   297,   204,   205,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   342,   343,   216,   360,   147,   217,   151,   279,
     218,   357,   114,   361,   212,   213,   288,   279,   133,   219,
     362,   208,   209,    24,   279,   114,    66,   381,   383,   393,
     223,   279,   279,   279,   365,   186,   395,   401,   281,   240,
     279,   279,   283,   288,   222,   133,   186,   127,   305,   306,
     307,   308,   214,   215,   146,   289,   350,   256,   279,   253,
     374,   376,   332,   379,   255,   186,   257,   147,   258,   368,
     301,   302,   114,   295,   385,   387,   303,   304,   236,     1,
     260,     2,   262,   263,    66,   397,   284,     3,   247,   151,
     285,   291,   345,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    41,   317,   318,
     114,   186,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,   114,   309,   310,   319,   329,   331,   359,   336,
     186,   186,   186,   339,   242,   346,    23,   344,   147,   348,
     349,   352,   353,    24,   363,   186,   380,   390,   311,   367,
     186,   313,   312,   186,   186,   314,   186,   371,   372,   373,
     142,   330,   315,   186,   356,   186,   186,   156,   250,   286,
     233,   186,   382,    74,     0,     0,   146,   389,     0,     0,
     391,   392,     0,   394,     0,     0,     0,     0,     0,     0,
     398,     0,   399,   400,     0,     0,     0,   157,   402,     2,
      93,    94,    95,    96,    97,    98,    99,   100,   101,     3,
     102,   103,     0,     0,     0,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     0,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       0,   158,   159,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,     0,   104,     0,   358,     0,     0,     0,
     106,   107,   108,   109,   110,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   169,   170,   171,   157,     0,
       2,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       0,   102,   103,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   196,   197,   198,     0,     0,     0,     0,
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,   158,   159,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   104,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   277,   199,     0,
     200,     0,   201,     0,     0,     0,   169,   170,   282,   157,
       0,     2,    93,    94,    95,    96,    97,    98,    99,   100,
     101,     0,   102,   103,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     0,     0,   157,     0,     2,    93,
      94,    95,    96,    97,    98,    99,   100,   101,     0,   102,
     103,     0,     0,   158,   159,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   104,     0,    80,     0,
      81,     0,   106,   107,   108,   109,   110,   111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   169,   170,  -206,
     158,   159,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,     0,   104,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   169,   170,     2,    93,    94,    95,
      96,    97,    98,    99,   100,   101,     0,   102,   103,     0,
       0,     0,     0,     0,     2,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,   102,   103,     0,     0,     0,
       0,     2,    93,    94,    95,    96,    97,    98,    99,   100,
     101,     0,   102,   103,     0,     0,     0,     2,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,   102,   103,
       0,   104,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,     0,     0,     0,     0,     0,     0,   104,
       0,     0,     0,   235,   369,   106,   107,   108,   109,   110,
     111,     0,     0,     0,     0,     0,   104,     0,     0,     0,
       0,   235,   106,   107,   108,   109,   110,   111,     0,     0,
       0,     0,   104,     0,     0,     0,     0,   264,   106,   107,
     108,   109,   110,   111,     0,     0,     0,   146,     0,     0,
       0,     0,     0,   337,     2,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,   102,   103,     0,     0,     0,
       2,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       3,   102,   103,     0,     0,     0,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       0,     0,     2,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,   102,   103,     0,     0,     0,     0,   104,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,     0,     0,     0,     0,   104,     0,     0,     0,     0,
     364,   106,   107,   108,   109,   110,   111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   378,     2,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   104,   102,   103,
     105,     0,     0,   106,   107,   108,   109,   110,   111,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     0,     0,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,     2,    93,
      94,    95,    96,    97,    98,    99,   100,   101,     0,   102,
     103,     0,   104,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,     2,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,   102,   103,     2,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,   102,   103,
       2,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       0,   102,   103,   104,     0,     0,   227,     0,     0,   106,
     107,   108,   109,   110,   111,     2,    93,    94,    95,    96,
      97,    98,    99,   100,   101,     0,   102,   103,     0,   104,
     293,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,     0,   104,     0,     0,   322,     0,     0,   106,   107,
     108,   109,   110,   111,     0,   104,   375,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,     2,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,   102,   103,
     104,   384,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,     2,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,   102,   103,     2,    93,    94,    95,    96,
      97,    98,    99,   100,   101,     0,   102,   103,     2,    93,
      94,    95,    96,    97,    98,    99,   100,   101,     0,   102,
     103,     0,   104,   386,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,     2,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,   102,   103,   104,   396,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,     0,
     188,     0,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,     0,   190,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,    73,     1,     0,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   132,   224,   133,     0,     0,     0,
       0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     0,     0,    59,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,     0,     0,
       0,     0,     0,    91,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     0,     0,     0,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     145,   288,   224,   133,     0,     0,     0,     0,    24,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   320,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,   232,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22
};

static const short yycheck[] =
{
       0,    63,   148,    24,    23,    36,   135,    26,     0,    66,
     235,    24,     3,     3,     3,     3,     0,    37,    69,    91,
      69,   104,   115,    23,    73,    46,    26,     3,     3,     3,
      30,    34,    32,    46,   104,   133,    36,    37,    38,    73,
      48,    49,    61,    27,    28,    23,    38,    66,    51,    33,
      73,    73,    36,    66,    38,    89,    56,   155,    73,    78,
     158,    61,    83,    89,    63,    91,    66,    75,    91,    91,
      62,   133,   144,   145,    90,     3,    91,   147,    78,    68,
      68,   151,    70,   104,    90,   168,    75,   143,    88,    89,
      82,    91,    68,   155,    68,    90,   158,    68,    87,    90,
      90,    75,   101,   102,   103,   188,    73,   190,    86,    73,
     203,   204,   205,   132,    69,   135,   115,   200,   188,   132,
      73,    83,    89,    73,    73,    89,   147,   148,     3,   354,
     151,   150,   132,   231,   133,   135,    89,   194,   221,    89,
      68,   141,   104,   199,   144,   145,   244,    75,   132,    68,
     150,    70,    73,   153,    88,   139,   155,    88,    73,   158,
     289,    89,    73,   163,    68,   165,    70,   188,    89,   231,
      18,    19,    87,   256,   257,   258,   176,   260,    89,   235,
     180,   194,   244,    69,   330,   147,   148,    73,   180,   151,
     163,    76,    77,    68,   266,    70,   196,    75,   291,   230,
      75,   201,    80,    81,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   278,   279,    74,    69,   188,    84,   249,    73,
      85,   329,   231,    69,    82,    83,    68,    73,    70,    22,
      69,    16,    17,    75,    73,   244,   230,    69,    69,    69,
      11,    73,    73,    73,   337,   255,    69,    69,   176,    89,
      73,    73,   180,    68,    71,    70,   266,   329,   210,   211,
     212,   213,    20,    21,     1,   288,    71,    68,    73,    89,
     363,   364,   255,   366,    87,   285,    68,   249,    68,   351,
     206,   207,   291,   349,   377,   378,   208,   209,   354,     1,
      68,     3,    89,    89,   288,   388,    91,    34,   327,   330,
      87,    69,   285,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,   327,    69,    69,
     329,   331,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,   351,   214,   215,    71,    87,    87,   331,    60,
     360,   361,   362,    89,    91,    69,    68,    91,   330,    69,
      73,    69,    71,    75,    68,   375,    58,    89,   216,   349,
     380,   218,   217,   383,   384,   219,   386,   360,   361,   362,
      78,   249,   220,   393,   327,   395,   396,    88,   153,   188,
     139,   401,   375,    38,    -1,    -1,     1,   380,    -1,    -1,
     383,   384,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,
     393,    -1,   395,   396,    -1,    -1,    -1,     1,   401,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    34,
      14,    15,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    -1,    59,    60,    61,    62,    63,
      64,    65,    66,    -1,    68,    -1,    91,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    91,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    79,    88,    68,    -1,
      70,    -1,    72,    -1,    -1,    -1,    89,    90,    91,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,    -1,    55,    56,    57,    -1,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    68,    -1,    88,    -1,
      90,    -1,    74,    75,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      55,    56,    57,    -1,    59,    60,    61,    62,    63,    64,
      65,    66,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    90,    91,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    90,    74,    75,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    89,    74,    75,
      76,    77,    78,    79,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    89,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      34,    14,    15,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      89,    74,    75,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    68,    14,    15,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    79,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    68,    -1,    -1,    71,    -1,    -1,    74,
      75,    76,    77,    78,    79,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    68,
      69,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    -1,    68,    -1,    -1,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    -1,    68,    69,    -1,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    79,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      68,    69,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,    68,    69,    -1,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    79,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    68,    69,    -1,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    79,     0,     1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    90,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    -1,
      -1,    -1,    -1,    90,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    68,    69,    70,    -1,    -1,    -1,    -1,    75,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    68,    75,   114,   115,   119,   120,   121,
     125,   131,   132,   135,   137,   138,   139,   141,   162,   163,
     164,   167,    89,    91,   137,   135,   136,   141,    89,   116,
     117,   137,   115,   115,    90,   167,    90,   167,   115,    90,
     114,   115,   156,    70,   140,    69,   115,   142,   143,   144,
     145,   167,   138,     0,   163,    69,   135,   141,    73,    89,
      88,    90,   156,   122,   123,   133,   134,   167,    90,   165,
     137,    90,   114,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    14,    15,    68,    71,    74,    75,    76,    77,
      78,    79,    93,    94,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   113,   167,
     168,    68,    68,    70,   137,   141,   147,   148,    69,    73,
      69,    73,   117,   118,   166,    90,     1,   120,   126,   127,
     128,   135,    90,    73,    91,    88,   133,     1,    55,    56,
      57,    59,    60,    61,    62,    63,    64,    65,    66,    89,
      90,    91,    96,   109,   110,   112,   151,   152,   153,   155,
     156,   157,   158,   159,   160,   161,   167,   155,    68,    96,
      68,    96,    96,   112,   128,   146,    13,    14,    15,    68,
      70,    72,    98,    75,    80,    81,    76,    77,    16,    17,
      18,    19,    82,    83,    20,    21,    74,    84,    85,    22,
      23,    86,    71,    11,    69,   142,   147,    71,   113,   148,
      68,    70,    54,   144,   167,    90,   110,   149,   155,   155,
      89,   128,    91,   127,    87,   129,   130,   137,   128,   124,
     134,   113,    91,    89,   113,    87,    68,    68,    68,   151,
      68,   167,    89,    89,    89,   112,   154,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    88,   111,    73,
      89,   157,    91,   157,    91,    87,   146,    69,    68,   141,
     147,    69,   167,    69,    95,   110,   112,   167,    98,    98,
      98,    99,    99,   100,   100,   101,   101,   101,   101,   102,
     102,   103,   104,   105,   106,   107,   112,    69,    69,    71,
      69,   142,    71,   113,   149,   150,   113,    73,    89,    87,
     126,    87,   151,   112,   112,   112,    60,    89,   112,    89,
      89,   155,   110,   110,    91,   151,    69,    98,    69,    73,
      71,    87,    69,    71,    73,    91,   130,   113,    91,   151,
      69,    69,    69,    68,    89,   112,    89,    95,   109,    91,
     149,   151,   151,   151,   112,    69,   112,    89,    89,   112,
      58,    69,   151,    69,    69,   112,    69,   112,    89,   151,
      89,   151,   151,    69,   151,    69,    69,   112,   151,   151,
     151,    69,   151
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 140 "parse.y"
    {
      yyval.y_exptree = newVar( yyvsp[0].y_id );
    }
    break;

  case 3:
#line 144 "parse.y"
    {
      yyval.y_exptree = newIntConst( yyvsp[0].y_int );
    }
    break;

  case 4:
#line 148 "parse.y"
    {
      yyval.y_exptree = newFpConst( yyvsp[0].y_string, typeBuildBasic( TYDOUBLE, NO_QUAL ) );
    }
    break;

  case 5:
#line 152 "parse.y"
    {
      yyval.y_exptree = newStringLit( yyvsp[0].y_string,
        typeBuildPointer(typeBuildBasic(TYSIGNEDCHAR, NO_QUAL), NO_QUAL) );
    }
    break;

  case 6:
#line 157 "parse.y"
    {
      yyval.y_exptree = newLongConst( yyvsp[0].y_long );
    }
    break;

  case 7:
#line 161 "parse.y"
    {
      yyval.y_exptree = newFpConst( yyvsp[0].y_string, typeBuildBasic( TYFLOAT, NO_QUAL ) );
    }
    break;

  case 8:
#line 165 "parse.y"
    {
      yyval.y_exptree = newUIntConst( yyvsp[0].y_uint );
    }
    break;

  case 9:
#line 169 "parse.y"
    {
      yyval.y_exptree = newULongConst( yyvsp[0].y_ulong );
    }
    break;

  case 10:
#line 173 "parse.y"
    {
      yyval.y_exptree = newFpConst( yyvsp[0].y_string, typeBuildBasic( TYLONGDOUBLE, NO_QUAL ) );
    }
    break;

  case 11:
#line 177 "parse.y"
    {
      yyval.y_exptree = yyvsp[-1].y_exptree;
    }
    break;

  case 12:
#line 184 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 13:
#line 188 "parse.y"
    {
      yyval.y_exptree = newBinop( INDEX_OP, NULL, yyvsp[-3].y_exptree, yyvsp[-1].y_exptree );
    }
    break;

  case 14:
#line 192 "parse.y"
    {
      yyval.y_exptree = newFcall( NULL, yyvsp[-2].y_exptree, NULL );
    }
    break;

  case 15:
#line 196 "parse.y"
    {
      yyval.y_exptree = newFcall( NULL, yyvsp[-3].y_exptree, yyvsp[-1].y_exptree );
    }
    break;

  case 16:
#line 200 "parse.y"
    {
      yyval.y_exptree = newFieldRef( yyvsp[0].y_id, NULL, yyvsp[-2].y_exptree );
    }
    break;

  case 17:
#line 204 "parse.y"
    {
      yyval.y_exptree = newPtr( yyvsp[0].y_id, NULL, yyvsp[-2].y_exptree );
    }
    break;

  case 18:
#line 208 "parse.y"
    {
      yyval.y_exptree = newUnop( INCRA_OP, NULL, yyvsp[-1].y_exptree );
    }
    break;

  case 19:
#line 212 "parse.y"
    {
      yyval.y_exptree = newUnop( DECRA_OP, NULL, yyvsp[-1].y_exptree );
    }
    break;

  case 20:
#line 219 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 21:
#line 223 "parse.y"
    {
      yyval.y_exptree = newEseq( NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 22:
#line 230 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 23:
#line 234 "parse.y"
    {
      yyval.y_exptree = newUnop( INCRB_OP, NULL, yyvsp[0].y_exptree );
    }
    break;

  case 24:
#line 238 "parse.y"
    {
      yyval.y_exptree = newUnop( DECRB_OP, NULL, yyvsp[0].y_exptree );
    }
    break;

  case 25:
#line 242 "parse.y"
    {
      yyval.y_exptree = newUnop( yyvsp[-1].y_treeop, NULL, yyvsp[0].y_exptree );
    }
    break;

  case 26:
#line 246 "parse.y"
    {
      yyval.y_exptree = newUnop( SIZEOF_OP, NULL, yyvsp[0].y_exptree );
    }
    break;

  case 27:
#line 250 "parse.y"
    {
      yyval.y_exptree = newIntConst(computeSize(yyvsp[-1].y_type));
    }
    break;

  case 28:
#line 257 "parse.y"
    {
      yyval.y_treeop = ADDR_OF_OP;
    }
    break;

  case 29:
#line 261 "parse.y"
    {
      yyval.y_treeop = DEREF_OP;
    }
    break;

  case 30:
#line 265 "parse.y"
    {
      yyval.y_treeop = UADD_OP;
    }
    break;

  case 31:
#line 269 "parse.y"
    {
      yyval.y_treeop = USUB_OP;
    }
    break;

  case 32:
#line 273 "parse.y"
    {
      yyval.y_treeop = COMPLMT_OP;
    }
    break;

  case 33:
#line 277 "parse.y"
    {
      yyval.y_treeop = LNOT_OP;
    }
    break;

  case 34:
#line 284 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 35:
#line 288 "parse.y"
    {
      yyval.y_exptree = newCastop( yyvsp[-2].y_type, NULL, yyvsp[0].y_exptree );
    }
    break;

  case 36:
#line 295 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 37:
#line 299 "parse.y"
    {
      yyval.y_exptree = newBinop( MULT_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 38:
#line 303 "parse.y"
    {
      yyval.y_exptree = newBinop( DIV_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 39:
#line 307 "parse.y"
    {
      yyval.y_exptree = newBinop( MOD_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 40:
#line 314 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 41:
#line 318 "parse.y"
    {
      yyval.y_exptree = newBinop( ADD_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 42:
#line 322 "parse.y"
    {
      yyval.y_exptree = newBinop( SUB_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 43:
#line 329 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 44:
#line 333 "parse.y"
    {
      yyval.y_exptree = newBinop( LSHIFT_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 45:
#line 337 "parse.y"
    {
      yyval.y_exptree = newBinop( RSHIFT_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 46:
#line 344 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 47:
#line 348 "parse.y"
    {
      yyval.y_exptree = newBinop( LT_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 48:
#line 352 "parse.y"
    {
      yyval.y_exptree = newBinop( GT_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 49:
#line 356 "parse.y"
    {
      yyval.y_exptree = newBinop( LTE_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 50:
#line 360 "parse.y"
    {
      yyval.y_exptree = newBinop( GTE_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 51:
#line 367 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 52:
#line 371 "parse.y"
    {
      yyval.y_exptree = newBinop( EQL_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 53:
#line 375 "parse.y"
    {
      yyval.y_exptree = newBinop( NEQL_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 54:
#line 382 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 55:
#line 386 "parse.y"
    {
      yyval.y_exptree = newBinop( ANDD_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 56:
#line 393 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 57:
#line 397 "parse.y"
    {
      yyval.y_exptree = newBinop( XORR_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 58:
#line 404 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 59:
#line 408 "parse.y"
    {
      yyval.y_exptree = newBinop( ORR_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 60:
#line 415 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 61:
#line 419 "parse.y"
    {
      yyval.y_exptree = newBinop( LAND_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 62:
#line 426 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 63:
#line 430 "parse.y"
    {
      yyval.y_exptree = newBinop( LOR_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 64:
#line 437 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 65:
#line 441 "parse.y"
    {
      yyval.y_exptree = newTriop( COND_OP, NULL, yyvsp[-4].y_exptree, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 66:
#line 448 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 67:
#line 452 "parse.y"
    {
      yyval.y_exptree = newBinop( yyvsp[-1].y_treeop, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 68:
#line 459 "parse.y"
    {
      yyval.y_treeop = ASSIGN_OP;
    }
    break;

  case 69:
#line 463 "parse.y"
    {
      yyval.y_treeop = MULT_ASSIGN_OP;
    }
    break;

  case 70:
#line 467 "parse.y"
    {
      yyval.y_treeop = DIV_ASSIGN_OP;
    }
    break;

  case 71:
#line 471 "parse.y"
    {
      yyval.y_treeop = MOD_ASSIGN_OP;
    }
    break;

  case 72:
#line 475 "parse.y"
    {
      yyval.y_treeop = ADD_ASSIGN_OP;
    }
    break;

  case 73:
#line 479 "parse.y"
    {
      yyval.y_treeop = SUB_ASSIGN_OP;
    }
    break;

  case 74:
#line 483 "parse.y"
    {
      yyval.y_treeop = LEFT_ASSIGN_OP;
    }
    break;

  case 75:
#line 487 "parse.y"
    {
      yyval.y_treeop = RIGHT_ASSIGN_OP;
    }
    break;

  case 76:
#line 491 "parse.y"
    {
      yyval.y_treeop = AND_ASSIGN_OP;
    }
    break;

  case 77:
#line 495 "parse.y"
    {
      yyval.y_treeop = XOR_ASSIGN_OP;
    }
    break;

  case 78:
#line 499 "parse.y"
    {
      yyval.y_treeop = OR_ASSIGN_OP;
    }
    break;

  case 79:
#line 506 "parse.y"
    {
      yyval.y_exptree = yyvsp[0].y_exptree;
    }
    break;

  case 80:
#line 510 "parse.y"
    {
      yyval.y_exptree = newBinop( COMMA_OP, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_exptree );
    }
    break;

  case 81:
#line 517 "parse.y"
    {
      yyval.y_exptree = reduceConstExpr(yyvsp[0].y_exptree);
      if (typeQuery(yyval.y_exptree->type) == TYERROR)
      {
        errorT((Tree)yyval.y_exptree, "malformed constant expression");
      }
    }
    break;

  case 82:
#line 528 "parse.y"
    {
        /* if the specifier is not union/struct/enum, it's an error */
        /* if yes, check whether need to install tag:
         * case: struct a;  yes
         * case: struct a { int  a; }; no
         */
        declarationWithoutDeclarator( yyvsp[-1].y_bucket_ptr );

        g_id_lookup = ON;   /*  lsr,  05/10/01 */
    }
    break;

  case 83:
#line 539 "parse.y"
    {
     /* check whether we need to install tag if specifier is struct/union */
     /* case: struct a { int a; } b;    No
      * case: struct a *p, *q;      if struct a defined before NO
      *                             otherwise install
      * case: struct a p;           if struct a defined before NO
      *                             otherwise ERROR
      */
     beforeProcessDeclaration( yyvsp[-2].y_bucket_ptr );

     /****** install the TYPE with ID to symbol table and ******* 
      ****** generate code for the declaration, if necessary *******/
     processDeclaration(yyvsp[-2].y_bucket_ptr, yyvsp[-1].y_declarator_list);
     g_id_lookup = ON;   /*  lsr,  05/10/01 */
    }
    break;

  case 84:
#line 558 "parse.y"
    { 
     yyval.y_bucket_ptr = update_bucket( NULL, yyvsp[0].y_type_specifier, NULL ); 
   }
    break;

  case 85:
#line 562 "parse.y"
    {
     yyval.y_bucket_ptr = update_bucket( yyvsp[0].y_bucket_ptr, yyvsp[-1].y_type_specifier, NULL );
   }
    break;

  case 86:
#line 566 "parse.y"
    { 
     yyval.y_bucket_ptr = update_bucket( NULL, yyvsp[0].y_my_specifier.type_spec, yyvsp[0].y_my_specifier.type );
     if (yyvsp[0].y_my_specifier.err) set_bucket_err(yyval.y_bucket_ptr); 
   }
    break;

  case 87:
#line 571 "parse.y"
    {
     yyval.y_bucket_ptr = update_bucket( yyvsp[0].y_bucket_ptr, yyvsp[-1].y_my_specifier.type_spec, yyvsp[-1].y_my_specifier.type );
     if (yyvsp[-1].y_my_specifier.err) set_bucket_err(yyval.y_bucket_ptr); 
   }
    break;

  case 88:
#line 576 "parse.y"
    { 
     yyval.y_bucket_ptr = update_bucket( NULL, yyvsp[0].y_type_specifier, NULL ); 
   }
    break;

  case 89:
#line 580 "parse.y"
    {
     yyval.y_bucket_ptr = update_bucket( yyvsp[0].y_bucket_ptr, yyvsp[-1].y_type_specifier, NULL );
   }
    break;

  case 90:
#line 587 "parse.y"
    { 
      yyval.y_declarator_list = yyvsp[0].y_declarator_list;
    }
    break;

  case 91:
#line 591 "parse.y"
    {
      /* pjh: this builds list backwards! */
      yyvsp[0].y_declarator_list->next = yyvsp[-2].y_declarator_list;
      yyval.y_declarator_list = yyvsp[0].y_declarator_list;
    }
    break;

  case 92:
#line 600 "parse.y"
    {
      yyval.y_declarator_list = newDeclarator(yyvsp[0].y_decl_tree, NULL);  
    }
    break;

  case 93:
#line 604 "parse.y"
    {
      g_id_lookup = ON;
    }
    break;

  case 94:
#line 608 "parse.y"
    {
      info("initializers not yet supported");
      yyval.y_declarator_list = newDeclarator(yyvsp[-3].y_decl_tree, NULL);
    }
    break;

  case 95:
#line 615 "parse.y"
    { yyval.y_type_specifier = TYPEDEF_SPEC; }
    break;

  case 96:
#line 616 "parse.y"
    { yyval.y_type_specifier = EXTERN_SPEC;  }
    break;

  case 97:
#line 617 "parse.y"
    { yyval.y_type_specifier = STATIC_SPEC;  }
    break;

  case 98:
#line 618 "parse.y"
    { yyval.y_type_specifier = AUTO_SPEC;    }
    break;

  case 99:
#line 619 "parse.y"
    { yyval.y_type_specifier = REGISTER_SPEC;}
    break;

  case 100:
#line 624 "parse.y"
    {  
      yyval.y_my_specifier = newSpecifierObject(VOID_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 101:
#line 629 "parse.y"
    {  
      yyval.y_my_specifier = newSpecifierObject(CHAR_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 102:
#line 634 "parse.y"
    { 
      yyval.y_my_specifier = newSpecifierObject(SHORT_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 103:
#line 639 "parse.y"
    {  
      yyval.y_my_specifier = newSpecifierObject(INT_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 104:
#line 644 "parse.y"
    {  
      yyval.y_my_specifier = newSpecifierObject(LONG_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 105:
#line 649 "parse.y"
    {  
      yyval.y_my_specifier = newSpecifierObject(FLOAT_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 106:
#line 654 "parse.y"
    { 
      yyval.y_my_specifier = newSpecifierObject(DOUBLE_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 107:
#line 659 "parse.y"
    { 
      yyval.y_my_specifier = newSpecifierObject(SIGNED_SPEC);
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 108:
#line 664 "parse.y"
    { 
      yyval.y_my_specifier = newSpecifierObject(UNSIGNED_SPEC); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 109:
#line 669 "parse.y"
    { 
      yyval.y_my_specifier = yyvsp[0].y_my_specifier; 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 110:
#line 674 "parse.y"
    {
      resetEnumItemVal();    /*  lsr,  05/03/01 */
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
      yyval.y_my_specifier = yyvsp[0].y_my_specifier;
    }
    break;

  case 111:
#line 680 "parse.y"
    {
      yyval.y_my_specifier = getTypenameSpecifierObject(yyvsp[0].y_id); 
      g_id_lookup = OFF;    /*  lsr,  05/10/01 */
    }
    break;

  case 112:
#line 688 "parse.y"
    {
      g_id_lookup=ON;  /*  lsr,  05/10/01 */
    }
    break;

  case 113:
#line 692 "parse.y"
    {
        yyval.y_my_specifier = * buildStructUnionType( NULL, yyvsp[-4].y_type_specifier, yyvsp[-1].y_member_list ); /* lsr $3 to $4 */
    }
    break;

  case 114:
#line 696 "parse.y"
    {
        /* install struct tag in symbol table */
        yyval.y_my_specifier = * installTagWhenMemberListComing( yyvsp[0].y_id, yyvsp[-1].y_type_specifier );
    }
    break;

  case 115:
#line 701 "parse.y"
    {
      g_id_lookup=ON;  /*  lsr  05/10/01 */
    }
    break;

  case 116:
#line 706 "parse.y"
    {
        /* attach member list to the tag in the symbol table */
        /* note: $6 is struct_declaration_list--MEMBER_LIST */
        /* pay attention to how to use $3 */

        attachMemberList( yyvsp[-4].y_my_specifier, yyvsp[-1].y_member_list );
        yyval.y_my_specifier = yyvsp[-4].y_my_specifier;
    }
    break;

  case 117:
#line 715 "parse.y"
    {
        yyval.y_my_specifier = * buildStructUnionType( yyvsp[0].y_id, yyvsp[-1].y_type_specifier, NULL );
   }
    break;

  case 118:
#line 722 "parse.y"
    {
      g_id_lookup = OFF;   /*  lsr,  05/10/01 */
      yyval.y_type_specifier = STRUCT_SPEC;
    }
    break;

  case 119:
#line 727 "parse.y"
    {
      g_id_lookup = OFF;   /*  lsr,  05/10/01 */
      yyval.y_type_specifier = UNION_SPEC;
    }
    break;

  case 120:
#line 735 "parse.y"
    {
        yyval.y_member_list = yyvsp[0].y_member_list;
    }
    break;

  case 121:
#line 739 "parse.y"
    {
        yyval.y_member_list = mergeMemberList( yyvsp[-1].y_member_list, yyvsp[0].y_member_list );
    }
    break;

  case 122:
#line 746 "parse.y"
    {
    /* deal with struct tag, if present */
    beforeProcessDeclaration( yyvsp[-2].y_bucket_ptr );
    g_id_lookup = ON;    /*  lsr,  05/10/01 */

    yyval.y_member_list = createMemberList( yyvsp[-2].y_bucket_ptr, yyvsp[-1].y_declarator_list );
   }
    break;

  case 123:
#line 754 "parse.y"
    {
    g_id_lookup = ON;
    yyval.y_member_list = NULL;
   }
    break;

  case 124:
#line 762 "parse.y"
    {
       yyval.y_bucket_ptr = update_bucket( NULL, yyvsp[0].y_my_specifier.type_spec, yyvsp[0].y_my_specifier.type );
       if (yyvsp[0].y_my_specifier.err) set_bucket_err(yyval.y_bucket_ptr); 
    }
    break;

  case 125:
#line 767 "parse.y"
    {
       yyval.y_bucket_ptr = update_bucket( yyvsp[0].y_bucket_ptr, yyvsp[-1].y_my_specifier.type_spec, yyvsp[-1].y_my_specifier.type );
       if (yyvsp[-1].y_my_specifier.err) set_bucket_err(yyval.y_bucket_ptr); 
    }
    break;

  case 126:
#line 772 "parse.y"
    {
      yyval.y_bucket_ptr = update_bucket( NULL, yyvsp[0].y_type_specifier, NULL );
    }
    break;

  case 127:
#line 776 "parse.y"
    {
      yyval.y_bucket_ptr = update_bucket( yyvsp[0].y_bucket_ptr, yyvsp[-1].y_type_specifier, NULL );
    }
    break;

  case 128:
#line 783 "parse.y"
    {   /* copied from init_declarator_list, since they are similar*/
        yyval.y_declarator_list = yyvsp[0].y_declarator_list;
    }
    break;

  case 129:
#line 787 "parse.y"
    {   /* copied from init_declarator_list, since they are similar*/
        yyvsp[0].y_declarator_list->next = yyvsp[-2].y_declarator_list;
        yyval.y_declarator_list = yyvsp[0].y_declarator_list;
    }
    break;

  case 130:
#line 794 "parse.y"
    { yyval.y_declarator_list = newDeclarator( yyvsp[0].y_decl_tree, NULL ); }
    break;

  case 131:
#line 795 "parse.y"
    { info("bitfields not yet implemented!"); }
    break;

  case 132:
#line 796 "parse.y"
    { info("bitfields not yet implemented!"); }
    break;

  case 133:
#line 801 "parse.y"
    {
      yyval.y_my_specifier = processEnumIdName(NULL);  /*  lsr,  05/05/01 */
    }
    break;

  case 134:
#line 805 "parse.y"
    {
      yyval.y_my_specifier = processEnumIdName(yyvsp[-3].y_id);    /*  lsr,  05/05/01 */
    }
    break;

  case 135:
#line 809 "parse.y"
    {
      yyval.y_my_specifier = verifyEnumId(yyvsp[0].y_id);         /*  lsr,  05/05/01 */
    }
    break;

  case 136:
#line 816 "parse.y"
    {
      g_id_lookup = OFF;
    }
    break;

  case 139:
#line 828 "parse.y"
    {
      processEnumItem(yyvsp[0].y_id);    /*  lsr,  05/03/01 */
    }
    break;

  case 140:
#line 832 "parse.y"
    {
      setEnumItemVal(getConstExprValue(yyvsp[0].y_exptree));   /*  lsr, 05/03/01 */
      processEnumItem(yyvsp[-2].y_id);  /*  lsr, 05/03/01 */
    }
    break;

  case 141:
#line 839 "parse.y"
    {  yyval.y_type_specifier = CONST_SPEC; }
    break;

  case 142:
#line 840 "parse.y"
    { yyval.y_type_specifier = VOLATILE_SPEC;}
    break;

  case 143:
#line 845 "parse.y"
    {
      yyval.y_type_qualifier = convertSpecifierToQualifier(yyvsp[0].y_type_specifier);
    }
    break;

  case 144:
#line 849 "parse.y"
    {
      yyval.y_type_qualifier = addQualifierToList(yyvsp[-1].y_type_qualifier, convertSpecifierToQualifier(yyvsp[0].y_type_specifier));
    }
    break;

  case 145:
#line 856 "parse.y"
    {
      yyval.y_decl_tree = yyvsp[0].y_decl_tree;
    }
    break;

  case 146:
#line 860 "parse.y"
    {
      yyval.y_decl_tree = addPointersToDeclTree( yyvsp[-1].y_decl_tree, yyvsp[0].y_decl_tree );
    }
    break;

  case 147:
#line 867 "parse.y"
    {
      yyval.y_decl_tree = newIdDeclNode( yyvsp[0].y_id );
    }
    break;

  case 148:
#line 871 "parse.y"
    {
      yyval.y_decl_tree = yyvsp[-1].y_decl_tree;
    }
    break;

  case 149:
#line 875 "parse.y"
    {
      yyval.y_decl_tree = newArrayDeclNode(0, yyvsp[-2].y_decl_tree);  /* 0 indicates NO_DIM */
    }
    break;

  case 150:
#line 879 "parse.y"
    {
      /*
       *  Error detection done later, but want to use 0 to indicate
       *  no dimension present, so re-write user 0 (which is an error
       *  anyway) to -1.
       */
      long value = getConstExprValue(yyvsp[-1].y_exptree);
      if (value == 0) value = -1;
      yyval.y_decl_tree = newArrayDeclNode(value, yyvsp[-3].y_decl_tree);
    }
    break;

  case 151:
#line 890 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(yyvsp[-1].y_param_type_list.style, yyvsp[-1].y_param_type_list.list, yyvsp[-2].y_decl_tree);
    }
    break;

  case 152:
#line 894 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(OLDSTYLE, NULL, yyvsp[-1].y_decl_tree);
    }
    break;

  case 153:
#line 898 "parse.y"
    {
      /* Note: id list not kept so can't do oldstyle function definitions! */
      yyval.y_decl_tree = newFuncDeclNode(OLDSTYLE, NULL, yyvsp[-2].y_decl_tree);
    }
    break;

  case 154:
#line 906 "parse.y"
    {
      g_id_lookup = ON;
      yyval.y_decl_tree = yyvsp[0].y_decl_tree;
    }
    break;

  case 156:
#line 915 "parse.y"
    {
      yyval.y_decl_tree = newPointerDeclNode( NO_QUAL, NULL );
    }
    break;

  case 157:
#line 919 "parse.y"
    {
      yyval.y_decl_tree = newPointerDeclNode( yyvsp[0].y_type_qualifier, NULL );      
    }
    break;

  case 158:
#line 923 "parse.y"
    {
      yyval.y_decl_tree = newPointerDeclNode( NO_QUAL, yyvsp[0].y_decl_tree );
    }
    break;

  case 159:
#line 927 "parse.y"
    {
      yyval.y_decl_tree = newPointerDeclNode( yyvsp[-1].y_type_qualifier, yyvsp[0].y_decl_tree );
    }
    break;

  case 160:
#line 934 "parse.y"
    {
      yyval.y_param_type_list.list = yyvsp[0].y_param_list;
      yyval.y_param_type_list.style = PROTOTYPE;
    }
    break;

  case 161:
#line 939 "parse.y"
    {
      yyval.y_param_type_list.list = yyvsp[-2].y_param_list;
      yyval.y_param_type_list.style = DOT_DOT_DOT;
    }
    break;

  case 162:
#line 947 "parse.y"
    {
      yyval.y_param_list = yyvsp[0].y_param_list;
    }
    break;

  case 163:
#line 951 "parse.y"
    {
      yyval.y_param_list = appendToParamList(yyvsp[-2].y_param_list, yyvsp[0].y_param_list);
    }
    break;

  case 164:
#line 958 "parse.y"
    {
    /* deal with struct tag, if present */
    beforeProcessDeclaration( yyvsp[-1].y_bucket_ptr );
    g_id_lookup = ON;

    yyval.y_param_list = makeParamListNode(yyvsp[-1].y_bucket_ptr, yyvsp[0].y_decl_tree);
  }
    break;

  case 165:
#line 966 "parse.y"
    {
    /* deal with struct tag, if present */
    beforeProcessDeclaration( yyvsp[0].y_bucket_ptr );
    g_id_lookup = ON;    /*  lsr,  05/10/01 */

    yyval.y_param_list = makeParamListNode(yyvsp[0].y_bucket_ptr, NULL);
  }
    break;

  case 166:
#line 974 "parse.y"
    {
    /* deal with struct tag, if present */
    beforeProcessDeclaration( yyvsp[-1].y_bucket_ptr );
    g_id_lookup = ON;    /*  lsr,  05/10/01 */

    yyval.y_param_list = makeParamListNode(yyvsp[-1].y_bucket_ptr, yyvsp[0].y_decl_tree);
  }
    break;

  case 167:
#line 984 "parse.y"
    {}
    break;

  case 169:
#line 990 "parse.y"
    {
    yyval.y_type = build_base(yyvsp[0].y_bucket_ptr);
    g_id_lookup = ON;    /*  pjh,  04/28/02 */
  }
    break;

  case 170:
#line 995 "parse.y"
    {
    ST_ID ignoreID;
    BOOLEAN ignoreErr;
    g_id_lookup = ON;    /*  lsr,  05/10/01 */

    yyval.y_type = processDeclarator(yyvsp[0].y_decl_tree, build_base(yyvsp[-1].y_bucket_ptr), &ignoreID, &ignoreErr, NULL);
  }
    break;

  case 171:
#line 1006 "parse.y"
    {
      yyval.y_decl_tree = addPointersToDeclTree(yyvsp[0].y_decl_tree, NULL);
    }
    break;

  case 172:
#line 1010 "parse.y"
    {
      yyval.y_decl_tree = yyvsp[0].y_decl_tree;
    }
    break;

  case 173:
#line 1014 "parse.y"
    {
      yyval.y_decl_tree = addPointersToDeclTree(yyvsp[-1].y_decl_tree, yyvsp[0].y_decl_tree);
    }
    break;

  case 174:
#line 1021 "parse.y"
    {
      yyval.y_decl_tree = yyvsp[-1].y_decl_tree;
    }
    break;

  case 175:
#line 1025 "parse.y"
    {
      yyval.y_decl_tree = newArrayDeclNode(0, NULL);  /* 0 indicates NO_DIM */
    }
    break;

  case 176:
#line 1029 "parse.y"
    {
      /*
       *  Error detection done later, but want to use 0 to indicate
       *  no dimension present, so re-write user 0 (which is an error
       *  anyway) to -1.
       */
      long value = getConstExprValue(yyvsp[-1].y_exptree);
      if (value == 0) value = -1;
      yyval.y_decl_tree = newArrayDeclNode(value, NULL);
    }
    break;

  case 177:
#line 1040 "parse.y"
    {
      yyval.y_decl_tree = newArrayDeclNode(0, yyvsp[-2].y_decl_tree);  /* 0 indicates NO_DIM */
    }
    break;

  case 178:
#line 1044 "parse.y"
    {
      /*
       *  Error detection done later, but want to use 0 to indicate
       *  no dimension present, so re-write user 0 (which is an error
       *  anyway) to -1.
       */
      long value = getConstExprValue(yyvsp[-1].y_exptree);
      if (value == 0) value = -1;
      yyval.y_decl_tree = newArrayDeclNode(value, yyvsp[-3].y_decl_tree);
    }
    break;

  case 179:
#line 1055 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(OLDSTYLE, NULL, NULL);
    }
    break;

  case 180:
#line 1059 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(yyvsp[-1].y_param_type_list.style, yyvsp[-1].y_param_type_list.list, NULL);
    }
    break;

  case 181:
#line 1063 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(OLDSTYLE, NULL, yyvsp[-2].y_decl_tree);
    }
    break;

  case 182:
#line 1067 "parse.y"
    {
      yyval.y_decl_tree = newFuncDeclNode(yyvsp[-1].y_param_type_list.style, yyvsp[-1].y_param_type_list.list, yyvsp[-3].y_decl_tree);
    }
    break;

  case 183:
#line 1073 "parse.y"
    {}
    break;

  case 184:
#line 1074 "parse.y"
    {}
    break;

  case 185:
#line 1075 "parse.y"
    {}
    break;

  case 188:
#line 1085 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 189:
#line 1089 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 190:
#line 1093 "parse.y"
    {
      yyval.y_tree = (Tree) yyvsp[0].y_exptree;
    }
    break;

  case 191:
#line 1097 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 192:
#line 1101 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 193:
#line 1105 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 194:
#line 1109 "parse.y"
    {
      yyval.y_tree = newError();
    }
    break;

  case 195:
#line 1116 "parse.y"
    {
      yyval.y_tree = newLabel( yyvsp[-2].y_id, yyvsp[0].y_tree );
    }
    break;

  case 196:
#line 1120 "parse.y"
    {
      yyval.y_tree = newCase( yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 197:
#line 1124 "parse.y"
    {
      yyval.y_tree = newDefault( yyvsp[0].y_tree );
    }
    break;

  case 198:
#line 1131 "parse.y"
    {
        st_enter_block();
      }
    break;

  case 199:
#line 1135 "parse.y"
    {
        yyval.y_tree = yyvsp[0].y_tree;
#ifdef ST_DUMP
        st_dump_block(st_get_cur_block());
#endif
        st_exit_block();
      }
    break;

  case 200:
#line 1146 "parse.y"
    {
      yyval.y_tree = NULL;
    }
    break;

  case 201:
#line 1150 "parse.y"
    {
      yyval.y_tree = yyvsp[-1].y_tree;
    }
    break;

  case 202:
#line 1154 "parse.y"
    {
      yyval.y_tree = NULL;
    }
    break;

  case 203:
#line 1158 "parse.y"
    {
      yyval.y_tree = yyvsp[-1].y_tree;
    }
    break;

  case 206:
#line 1170 "parse.y"
    {
      yyval.y_tree = yyvsp[0].y_tree;
    }
    break;

  case 207:
#line 1174 "parse.y"
    {
      yyval.y_tree = newSeq( yyvsp[-1].y_tree, yyvsp[0].y_tree );
    }
    break;

  case 208:
#line 1180 "parse.y"
    {
      yyval.y_exptree = NULL;
    }
    break;

  case 209:
#line 1184 "parse.y"
    {
      yyval.y_exptree = yyvsp[-1].y_exptree;
    }
    break;

  case 210:
#line 1191 "parse.y"
    {
      yyval.y_tree = newIfElse( yyvsp[-2].y_exptree, yyvsp[0].y_tree, NULL );
    }
    break;

  case 211:
#line 1195 "parse.y"
    {
      yyval.y_tree = newIfElse( yyvsp[-4].y_exptree, yyvsp[-2].y_tree, yyvsp[0].y_tree );
    }
    break;

  case 212:
#line 1199 "parse.y"
    {
      yyval.y_tree = newSwitch( yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 213:
#line 1206 "parse.y"
    {
      yyval.y_tree = newWhile( yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 214:
#line 1210 "parse.y"
    {
      yyval.y_tree = newDoWhile( yyvsp[-5].y_tree, yyvsp[-2].y_exptree );
    }
    break;

  case 215:
#line 1214 "parse.y"
    {
      yyval.y_tree = newFor( NULL, NULL, NULL, yyvsp[0].y_tree );
    }
    break;

  case 216:
#line 1218 "parse.y"
    {
      yyval.y_tree = newFor( NULL, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 217:
#line 1222 "parse.y"
    {
      yyval.y_tree = newFor( NULL, yyvsp[-3].y_exptree, NULL, yyvsp[0].y_tree );
    }
    break;

  case 218:
#line 1226 "parse.y"
    {
      yyval.y_tree = newFor( NULL, yyvsp[-4].y_exptree, yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 219:
#line 1230 "parse.y"
    {
      yyval.y_tree = newFor( yyvsp[-4].y_exptree, NULL, NULL, yyvsp[0].y_tree );
    }
    break;

  case 220:
#line 1234 "parse.y"
    {
      yyval.y_tree = newFor( yyvsp[-5].y_exptree, NULL, yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 221:
#line 1238 "parse.y"
    {
      yyval.y_tree = newFor( yyvsp[-5].y_exptree, yyvsp[-3].y_exptree, NULL, yyvsp[0].y_tree );
    }
    break;

  case 222:
#line 1242 "parse.y"
    {
      yyval.y_tree = newFor( yyvsp[-6].y_exptree, yyvsp[-4].y_exptree, yyvsp[-2].y_exptree, yyvsp[0].y_tree );
    }
    break;

  case 223:
#line 1249 "parse.y"
    {
      yyval.y_tree = newGoto( yyvsp[-1].y_id );
    }
    break;

  case 224:
#line 1253 "parse.y"
    {
      yyval.y_tree = newContinue();
    }
    break;

  case 225:
#line 1257 "parse.y"
    {
      yyval.y_tree = newBreak();
    }
    break;

  case 226:
#line 1261 "parse.y"
    {
      yyval.y_tree = newReturn( NULL );
    }
    break;

  case 227:
#line 1265 "parse.y"
    {
      yyval.y_tree = newReturn( yyvsp[-1].y_exptree );
    }
    break;

  case 232:
#line 1279 "parse.y"
    {
      g_id_lookup = ON;
    }
    break;

  case 233:
#line 1283 "parse.y"
    {
      g_id_lookup = ON;
    }
    break;

  case 234:
#line 1290 "parse.y"
    {
      gCurrentFunctionOffset = 0;

      yyval.y_param_list =
        processFunctionDef(update_bucket(NULL, INT_SPEC, NULL), yyvsp[-1].y_decl_tree);

      st_enter_block();

      allocateStackSlotsForParameters(yyval.y_param_list);

      gCurrentFunctionOffset = adjustFunctionOffset(gCurrentFunctionOffset);
    }
    break;

  case 235:
#line 1303 "parse.y"
    {
      beforeAnalyze();
      yyvsp[0].y_tree = analyze(yyvsp[0].y_tree);
      afterAnalyze();
      encodeFunctionEntry(gCurrentFunctionName, gCurrentFunctionOffset, -1,
                          -1, gCurrentFunctionClass == STATIC_SC);
      encodeMoveParametersToLocalSlots(yyvsp[-1].y_param_list, yyvsp[0].y_tree);
      beforeEncode();
      encode(yyvsp[0].y_tree);
      freeExpressionStatementRegister(yyvsp[0].y_tree);
      afterEncode();
      encodeFunctionExit(gCurrentFunctionName, gCurrentFunctionOffset, -1, -1);
#ifdef PRINTTREE
      printTree(yyvsp[0].y_tree);
#endif
#ifdef ST_DUMP
      st_dump_block(st_get_cur_block());
#endif
      st_exit_block();
      poolReset();
    }
    break;

  case 236:
#line 1325 "parse.y"
    {
      info("old style functions not yet implemented");
    }
    break;

  case 237:
#line 1329 "parse.y"
    {
      gCurrentFunctionOffset = 0;

      yyval.y_param_list = processFunctionDef(yyvsp[-2].y_bucket_ptr, yyvsp[-1].y_decl_tree);

      st_enter_block();

      allocateStackSlotsForParameters(yyval.y_param_list);

      gCurrentFunctionOffset = adjustFunctionOffset(gCurrentFunctionOffset);
    }
    break;

  case 238:
#line 1341 "parse.y"
    {
      beforeAnalyze();
      yyvsp[0].y_tree = analyze(yyvsp[0].y_tree);
      afterAnalyze();
      encodeFunctionEntry(gCurrentFunctionName, gCurrentFunctionOffset, -1,
                          -1, gCurrentFunctionClass == STATIC_SC);
      encodeMoveParametersToLocalSlots(yyvsp[-1].y_param_list, yyvsp[0].y_tree);
      beforeEncode();
      encode(yyvsp[0].y_tree);
      freeExpressionStatementRegister(yyvsp[0].y_tree);
      afterEncode();
      encodeFunctionExit(gCurrentFunctionName, gCurrentFunctionOffset, -1, -1);
#ifdef PRINTTREE
      printTree(yyvsp[0].y_tree);
#endif
#ifdef ST_DUMP
      st_dump_block(st_get_cur_block());
#endif
      st_exit_block();
      poolReset();
    }
    break;

  case 239:
#line 1364 "parse.y"
    {
      info("old style functions not yet implemented");
    }
    break;

  case 240:
#line 1371 "parse.y"
    {
     yyval.y_id = yyvsp[0].y_id;
   }
    break;

  case 241:
#line 1378 "parse.y"
    {
      yyval.y_string = yyvsp[0].y_string;
    }
    break;

  case 242:
#line 1382 "parse.y"
    {
      yyval.y_string = concat(yyvsp[-1].y_string, yyvsp[0].y_string);
    }
    break;


    }

/* Line 999 of yacc.c.  */
#line 3567 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1387 "parse.y"


void yyerror(char *s)
{
  error("%s (column %d)", s, YYcolumnno());
}

/* Concatenates the second string literal onto the end of the first string
 * literal, removing the double quotes at the end of first, and the beginning
 * of second.
 *
 * Added by shillman on 2/2/2001. The string_literal yacc code was also added.
 */
static char* concat(char* first, char* second)
{
  char *temp, *temp2;
  size_t length1, length2;

  length1 = strlen(first);
  length2 = strlen(second);

  if( !(temp = (char *)malloc(length1+length2+1)) )
  {
    fatal("Could not allocate space for strings in concat, parse.y\n");
  }
  else
  {
    strcpy(temp, first);
    temp[length1-1] = '\0';
    strncat(temp, second+1, length2);
  }
  temp2 = st_save_string(temp);
  free(temp);
  return temp2;
}


